;     WRITTEN BY NMZ
EXECBASE     =       4
FINDTASK     =       -294
ADDPORT      =       -354
REMPORT      =       -360
OPENLIB      =       -408
CLOSELIB     =       -414
OPENDEV      =       -444
CLOSEDEV     =       -450
DOIO         =       -456

;---------------------------------
BOOTSECTOR:  DC.B     'DOS',0

             DC.L     0
             DC.L     880

             BSR      DEMO
             MOVE.L   EXECBASE,A6
             LEA      DOSNAME(PC), A1
             JSR      -96(A6)
             MOVE.L   D0,A0
             MOVE.L   22(A0),A0
             MOVEQ    #0,D0
             RTS
DEMO:        MOVE.W   #$27FF,D0
             LEA      $11000,A0
DEMO1:       MOVE.B   #0,(A0)+
             DBRA     D0,DEMO1
             MOVE.W   #PICTURELENGTH, D0
             LEA      $11000,A0
             LEA      PICTURE(PC), A1
DEMO2:       MOVE.B   (A1)+,(A0)+
             DBRA     D0,DEMO2
             MOVE.W   $DFF01C,INTENA
             MOVE.W   #$7FFF,$DFF09A
             MOVE.W   $DFF002,DMACON
             MOVE.W   #$00FF,$DFF096
             MOVE.W   #$8100,$DFF096
             MOVE.W   #100,D3
             MOVE.W   #30,D4
             MOVE.W   #2,D5
             MOVE.W   #2,D6
             CLR.W    D2
DEMO3:       BTST     #0,$DFF004
             BNE      DEMO3


             MOVE.W   #$1000,$DFF100
             MOVE.W   D3,$DFF102
             MOVE.W   #$0024,$DFF104
             MOVE.L   #$0011000,$DFF0E0
             MOVE.W   #$0000,$DFF108
             MOVE.W   D3,D7
             ASR.W    #1,D7
             ADD.W    #$30,D7
             MOVE.W   D7,$DFF092
             ADD.W    #$28,D7
             MOVE.W   D7,$DFF094
             MOVE.W   D4,D7
             ASL.W    #8,D7
             ADD.W    #$3070,D7
             MOVE.W   D7,$DFF08E
             MOVE.W   #$2BF0,$DFF090
             MOVE.W   #28,D0
             MOVE.W   D2,D1
             LEA      COLORTAB(PC),       A0
DEMO4:       CMP.B    $DFF006,D0
             BNE      DEMO4
	     MOVE.W   (A0,D1),D7	;D7=(A1+D1)
	     MOVE.W   D7,$DFF180	;Background color
             ASL.W    #4,D7		;D7=D7*16
	     MOVE.W   D7,$DFF182	;Text color
             ADD.W    #2,D1		;D1=(D1+2)AND 31
             AND.W    #$1F,D1
             ADD.W    #1,D0		;D0=D0+1
             CMP.W    #312,D0		;JMP to color2 if D0,'0'
             BNE      DEMO4
             ADD.W    #2,D2
             AND.W    #$1F,D2
             ADD.W    D5,D3
             ADD.W    D6,D4
             CMP.B    #0,D3
             BNE      DEMO5
             EOR.W    #$FFFF,D5
             ADD.W    #$1,D5
DEMO5:       MOVE.W   D4,D7
             AND      #127,D7
             BNE      DEMO6
             EOR.W    #$FFFF,D6
             ADD.W    #$1,D6
DEMO6:       BTST     #6,$BFE001
             BNE      DEMO3
             MOVE.W   DMACON,D0
             OR.W     #$8000,D0
             MOVE.W   #$0100,$DFF096
             MOVE.W   D0,$DFF096
             MOVE.W   INTENA,D0
             OR.W     #$8000,D0
             MOVE.W   D0,$DFF09A
             RTS
DOSNAME:     DC.B     'dos.library',0
INTENA:      DC.W     0
DMACON:      DC.W     0
COLORTAB:    DC.W     0,2,4,6,8,10,12,14,15,14,12,10,8,4,
PICTURE:     BLK.B    1024,0
PICTURELENGTH1   =           PICTURE-BOOTSECTOR
PICTURELENGTH    =           1024-PICTURELENGTH1
;-----------------------------------------------
WBOOT:       LEA      BOOTSECTOR,A0
             MOVE.L   #$FFFFFFFF,D0
             MOVE.L   #$FF,D1
             CLR.L    D2
WBOOT1:      SUB.L    (A0)+,D0
             SUBX.L   D2,D0
             DBRA     D1,WBOOT1
             MOVE.L   D0,BOOTSECTOR+$4
             MOVE.L   EXECBASE,A6
             MOVE.L   #0,A1
             JSR      FINDTASK(A6)
             MOVE.L   D0,WPORT+$10
             LEA      WPORT,A1
             JSR      ADDPORT(A6)
             LEA      WIO,A1
             MOVE.L   #0,D0

             CLR.L    D1
             LEA      WTRDDEVICE,A0
             JSR      OPENDEV(A6)
             TST.L    D0
             BNE      WERROR
             LEA      WIO,A1
             MOVE.L   #WPORT,14(A1)


             MOVE.W   #3,28(A1)
             MOVE.L   #BOOTSECTOR, 40(A1)
             MOVE.L   #2*512,36(A1)

             MOVE.L   #0*512,44(A1)

             JSR      DOIO(A6)
             MOVE.W   #4,28(A1)





             JSR      DOIO(A6)
             MOVE.W   #9,28(A1)
             MOVE.L   #0,36(A1)
             JSR      DOIO(A6)
             LEA      WPORT,A1
             JSR      REMPORT(A6)
             LEA      WIO,A1
             JSR      CLOSEDEV(A6)

WERROR:      RTS

WTRDDEVICE:  DC.B     'trackdisk.device',0
             EVEN
WIO:         BLK.L    20,0
WPORT:       BLK.L    8,0
